package net.goldorion.mbm.procedures;

import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.block.entity.BlockEntity;
import net.minecraft.world.level.block.Blocks;
import net.minecraft.world.level.LevelAccessor;
import net.minecraft.world.level.Level;
import net.minecraft.core.BlockPos;

import net.goldorion.mbm.init.MultiBlockMachineModBlocks;

public class BlocksCheckerProcedure {
	public static void execute(LevelAccessor world, double x, double y, double z) {
		BlockState frame = Blocks.AIR.defaultBlockState();
		BlockState interfaceBlock = Blocks.AIR.defaultBlockState();
		BlockState middleLineBlock = Blocks.AIR.defaultBlockState();
		BlockState crossBlockMiddleLayer = Blocks.AIR.defaultBlockState();
		frame = Blocks.DIAMOND_BLOCK.defaultBlockState();
		interfaceBlock = MultiBlockMachineModBlocks.INTERFACE_BLOCK.defaultBlockState();
		middleLineBlock = Blocks.REDSTONE_BLOCK.defaultBlockState();
		crossBlockMiddleLayer = Blocks.NETHERITE_BLOCK.defaultBlockState();
		if ((world.getBlockState(new BlockPos((int) (x + 1), (int) (y + 1), (int) (z + 1)))).getBlock() == (frame).getBlock()
				&& (world.getBlockState(new BlockPos((int) (x - 1), (int) (y + 1), (int) (z - 1)))).getBlock() == (frame).getBlock()
				&& (world.getBlockState(new BlockPos((int) (x + 1), (int) (y + 1), (int) (z - 1)))).getBlock() == (frame).getBlock()
				&& (world.getBlockState(new BlockPos((int) (x - 1), (int) (y + 1), (int) (z + 1)))).getBlock() == (frame).getBlock()
				&& (world.getBlockState(new BlockPos((int) x, (int) (y + 1), (int) z))).getBlock() == (frame).getBlock()
				&& (world.getBlockState(new BlockPos((int) (x + 1), (int) (y + 1), (int) z))).getBlock() == (middleLineBlock).getBlock()
				&& (world.getBlockState(new BlockPos((int) (x - 1), (int) (y + 1), (int) z))).getBlock() == (middleLineBlock).getBlock()
				&& (world.getBlockState(new BlockPos((int) x, (int) (y + 1), (int) (z + 1)))).getBlock() == (middleLineBlock).getBlock()
				&& (world.getBlockState(new BlockPos((int) x, (int) (y + 1), (int) (z - 1)))).getBlock() == (middleLineBlock).getBlock()
				&& (world.getBlockState(new BlockPos((int) (x + 1), (int) (y - 1), (int) (z + 1)))).getBlock() == (frame).getBlock()
				&& (world.getBlockState(new BlockPos((int) (x - 1), (int) (y - 1), (int) (z - 1)))).getBlock() == (frame).getBlock()
				&& (world.getBlockState(new BlockPos((int) (x + 1), (int) (y - 1), (int) (z - 1)))).getBlock() == (frame).getBlock()
				&& (world.getBlockState(new BlockPos((int) (x - 1), (int) (y - 1), (int) (z + 1)))).getBlock() == (frame).getBlock()
				&& (world.getBlockState(new BlockPos((int) x, (int) (y - 1), (int) z))).getBlock() == (frame).getBlock()
				&& (world.getBlockState(new BlockPos((int) (x + 1), (int) (y - 1), (int) z))).getBlock() == (middleLineBlock).getBlock()
				&& (world.getBlockState(new BlockPos((int) (x - 1), (int) (y - 1), (int) z))).getBlock() == (middleLineBlock).getBlock()
				&& (world.getBlockState(new BlockPos((int) x, (int) (y - 1), (int) (z + 1)))).getBlock() == (middleLineBlock).getBlock()
				&& (world.getBlockState(new BlockPos((int) x, (int) (y - 1), (int) (z - 1)))).getBlock() == (middleLineBlock).getBlock()
				&& (world.getBlockState(new BlockPos((int) (x + 1), (int) y, (int) (z + 1)))).getBlock() == (frame).getBlock()
				&& (world.getBlockState(new BlockPos((int) (x - 1), (int) y, (int) (z - 1)))).getBlock() == (frame).getBlock()
				&& (world.getBlockState(new BlockPos((int) (x + 1), (int) y, (int) (z - 1)))).getBlock() == (frame).getBlock()
				&& (world.getBlockState(new BlockPos((int) (x - 1), (int) y, (int) (z + 1)))).getBlock() == (frame).getBlock()) {
			if ((world.getBlockState(new BlockPos((int) (x + 1), (int) y, (int) z))).getBlock() == (interfaceBlock).getBlock()
					&& (world.getBlockState(new BlockPos((int) (x - 1), (int) y, (int) z))).getBlock() == (crossBlockMiddleLayer).getBlock()
					&& (world.getBlockState(new BlockPos((int) x, (int) y, (int) (z + 1)))).getBlock() == (crossBlockMiddleLayer).getBlock()
					&& (world.getBlockState(new BlockPos((int) x, (int) y, (int) (z - 1)))).getBlock() == (crossBlockMiddleLayer).getBlock()) {
				if (!world.isClientSide()) {
					BlockPos _bp = new BlockPos((int) (x + 1), (int) y, (int) z);
					BlockEntity _blockEntity = world.getBlockEntity(_bp);
					BlockState _bs = world.getBlockState(_bp);
					if (_blockEntity != null)
						_blockEntity.getTileData().putBoolean("canOpenInventory", (true));
					if (world instanceof Level _level)
						_level.sendBlockUpdated(_bp, _bs, _bs, 3);
				}
			} else if ((world.getBlockState(new BlockPos((int) (x + 1), (int) y, (int) z))).getBlock() == (crossBlockMiddleLayer).getBlock()
					&& (world.getBlockState(new BlockPos((int) (x - 1), (int) y, (int) z))).getBlock() == (interfaceBlock).getBlock()
					&& (world.getBlockState(new BlockPos((int) x, (int) y, (int) (z + 1)))).getBlock() == (crossBlockMiddleLayer).getBlock()
					&& (world.getBlockState(new BlockPos((int) x, (int) y, (int) (z - 1)))).getBlock() == (crossBlockMiddleLayer).getBlock()) {
				if (!world.isClientSide()) {
					BlockPos _bp = new BlockPos((int) (x - 1), (int) y, (int) z);
					BlockEntity _blockEntity = world.getBlockEntity(_bp);
					BlockState _bs = world.getBlockState(_bp);
					if (_blockEntity != null)
						_blockEntity.getTileData().putBoolean("canOpenInventory", (true));
					if (world instanceof Level _level)
						_level.sendBlockUpdated(_bp, _bs, _bs, 3);
				}
			} else if ((world.getBlockState(new BlockPos((int) (x + 1), (int) y, (int) z))).getBlock() == (crossBlockMiddleLayer).getBlock()
					&& (world.getBlockState(new BlockPos((int) (x - 1), (int) y, (int) z))).getBlock() == (crossBlockMiddleLayer).getBlock()
					&& (world.getBlockState(new BlockPos((int) x, (int) y, (int) (z + 1)))).getBlock() == (interfaceBlock).getBlock()
					&& (world.getBlockState(new BlockPos((int) x, (int) y, (int) (z - 1)))).getBlock() == (crossBlockMiddleLayer).getBlock()) {
				if (!world.isClientSide()) {
					BlockPos _bp = new BlockPos((int) x, (int) y, (int) (z + 1));
					BlockEntity _blockEntity = world.getBlockEntity(_bp);
					BlockState _bs = world.getBlockState(_bp);
					if (_blockEntity != null)
						_blockEntity.getTileData().putBoolean("canOpenInventory", (true));
					if (world instanceof Level _level)
						_level.sendBlockUpdated(_bp, _bs, _bs, 3);
				}
			} else if ((world.getBlockState(new BlockPos((int) (x + 1), (int) y, (int) z))).getBlock() == (crossBlockMiddleLayer).getBlock()
					&& (world.getBlockState(new BlockPos((int) (x - 1), (int) y, (int) z))).getBlock() == (crossBlockMiddleLayer).getBlock()
					&& (world.getBlockState(new BlockPos((int) x, (int) y, (int) (z + 1)))).getBlock() == (crossBlockMiddleLayer).getBlock()
					&& (world.getBlockState(new BlockPos((int) x, (int) y, (int) (z - 1)))).getBlock() == (interfaceBlock).getBlock()) {
				if (!world.isClientSide()) {
					BlockPos _bp = new BlockPos((int) x, (int) y, (int) (z - 1));
					BlockEntity _blockEntity = world.getBlockEntity(_bp);
					BlockState _bs = world.getBlockState(_bp);
					if (_blockEntity != null)
						_blockEntity.getTileData().putBoolean("canOpenInventory", (true));
					if (world instanceof Level _level)
						_level.sendBlockUpdated(_bp, _bs, _bs, 3);
				}
			} else {
				if ((world.getBlockState(new BlockPos((int) (x + 1), (int) y, (int) z))).getBlock() == (interfaceBlock).getBlock()) {
					if (!world.isClientSide()) {
						BlockPos _bp = new BlockPos((int) (x + 1), (int) y, (int) z);
						BlockEntity _blockEntity = world.getBlockEntity(_bp);
						BlockState _bs = world.getBlockState(_bp);
						if (_blockEntity != null)
							_blockEntity.getTileData().putBoolean("canOpenInventory", (false));
						if (world instanceof Level _level)
							_level.sendBlockUpdated(_bp, _bs, _bs, 3);
					}
				} else if ((world.getBlockState(new BlockPos((int) (x - 1), (int) y, (int) z))).getBlock() == (interfaceBlock).getBlock()) {
					if (!world.isClientSide()) {
						BlockPos _bp = new BlockPos((int) (x - 1), (int) y, (int) z);
						BlockEntity _blockEntity = world.getBlockEntity(_bp);
						BlockState _bs = world.getBlockState(_bp);
						if (_blockEntity != null)
							_blockEntity.getTileData().putBoolean("canOpenInventory", (false));
						if (world instanceof Level _level)
							_level.sendBlockUpdated(_bp, _bs, _bs, 3);
					}
				} else if ((world.getBlockState(new BlockPos((int) x, (int) y, (int) (z + 1)))).getBlock() == (interfaceBlock).getBlock()) {
					if (!world.isClientSide()) {
						BlockPos _bp = new BlockPos((int) x, (int) y, (int) (z + 1));
						BlockEntity _blockEntity = world.getBlockEntity(_bp);
						BlockState _bs = world.getBlockState(_bp);
						if (_blockEntity != null)
							_blockEntity.getTileData().putBoolean("canOpenInventory", (false));
						if (world instanceof Level _level)
							_level.sendBlockUpdated(_bp, _bs, _bs, 3);
					}
				} else if ((world.getBlockState(new BlockPos((int) x, (int) y, (int) (z - 1)))).getBlock() == (interfaceBlock).getBlock()) {
					if (!world.isClientSide()) {
						BlockPos _bp = new BlockPos((int) x, (int) y, (int) (z - 1));
						BlockEntity _blockEntity = world.getBlockEntity(_bp);
						BlockState _bs = world.getBlockState(_bp);
						if (_blockEntity != null)
							_blockEntity.getTileData().putBoolean("canOpenInventory", (false));
						if (world instanceof Level _level)
							_level.sendBlockUpdated(_bp, _bs, _bs, 3);
					}
				}
			}
		} else {
			if ((world.getBlockState(new BlockPos((int) (x + 1), (int) y, (int) z))).getBlock() == (interfaceBlock).getBlock()) {
				if (!world.isClientSide()) {
					BlockPos _bp = new BlockPos((int) (x + 1), (int) y, (int) z);
					BlockEntity _blockEntity = world.getBlockEntity(_bp);
					BlockState _bs = world.getBlockState(_bp);
					if (_blockEntity != null)
						_blockEntity.getTileData().putBoolean("canOpenInventory", (false));
					if (world instanceof Level _level)
						_level.sendBlockUpdated(_bp, _bs, _bs, 3);
				}
			} else if ((world.getBlockState(new BlockPos((int) (x - 1), (int) y, (int) z))).getBlock() == (interfaceBlock).getBlock()) {
				if (!world.isClientSide()) {
					BlockPos _bp = new BlockPos((int) (x - 1), (int) y, (int) z);
					BlockEntity _blockEntity = world.getBlockEntity(_bp);
					BlockState _bs = world.getBlockState(_bp);
					if (_blockEntity != null)
						_blockEntity.getTileData().putBoolean("canOpenInventory", (false));
					if (world instanceof Level _level)
						_level.sendBlockUpdated(_bp, _bs, _bs, 3);
				}
			} else if ((world.getBlockState(new BlockPos((int) x, (int) y, (int) (z + 1)))).getBlock() == (interfaceBlock).getBlock()) {
				if (!world.isClientSide()) {
					BlockPos _bp = new BlockPos((int) x, (int) y, (int) (z + 1));
					BlockEntity _blockEntity = world.getBlockEntity(_bp);
					BlockState _bs = world.getBlockState(_bp);
					if (_blockEntity != null)
						_blockEntity.getTileData().putBoolean("canOpenInventory", (false));
					if (world instanceof Level _level)
						_level.sendBlockUpdated(_bp, _bs, _bs, 3);
				}
			} else if ((world.getBlockState(new BlockPos((int) x, (int) y, (int) (z - 1)))).getBlock() == (interfaceBlock).getBlock()) {
				if (!world.isClientSide()) {
					BlockPos _bp = new BlockPos((int) x, (int) y, (int) (z - 1));
					BlockEntity _blockEntity = world.getBlockEntity(_bp);
					BlockState _bs = world.getBlockState(_bp);
					if (_blockEntity != null)
						_blockEntity.getTileData().putBoolean("canOpenInventory", (false));
					if (world instanceof Level _level)
						_level.sendBlockUpdated(_bp, _bs, _bs, 3);
				}
			}
		}
	}
}
